`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    14:06:44 03/09/2007 
// Design Name: 
// Module Name:    addsubctl 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: This module does the add/subtract/Shift control
// We feed in the bit stream from the multiplier, and based on
// the current value of the bit plus the value of the last bit
// this thing will decide if the mulitplier cells need to a shift
// or an add/subtract and also if add/subtract, if it is add or
// subtract...all very complicated.
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module addsubctl(C, R, sC, I,en, E, A);
	input C;		//clock
	input R;		//reset
	input sC;	//synchronous clear
	input I;		//multiplier input
	input en;	//enable
	output E;	//add-sub/not_shift
	output A;	//add/notsub
	
	wire E,A;
	reg Ym1;
	
	always @ (posedge C or posedge R) begin
		if(R)
			Ym1 <= 0;	//system reset
		else if(sC)
			Ym1 <= 0;	//clear register
		else if(en)
			Ym1 <= I;	//remember previous multiplier
	end

	assign E = Ym1 ^ I;	//determins if it is a shift or Add/subtract operation
	assign A = I;			//add or subtract depends on I only (input bit)
	
endmodule
