`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    12:39:10 03/09/2007 
// Design Name: 
// Module Name:    multcell 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: Multiplier Cell...this cell can be cascaded to any depth
// required.
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module multcell(C, R,sC, M, L, I, A, E,en, O);
    input C;		//system clock
    input R;		//reset
	 input sC;		//synchronous clear
    input M;		//multiplicand
	 input L;		//load
    input I;		//Carry In
	 input A;		//add/not-subtract
	 input E;		//add/not_shift
	 input en;		//enable
    output O;		//product 

	reg sum;
	reg carry;
	reg Mc;
	
	//--------------------------------------------
	// This file basically implements a serial
	// adder/subtractor
	// Sum register
	//--------------------------------------------
	always @ (posedge C or posedge R)
		if(R)
			sum <= 0;
		else if (sC)
			sum <= 0;
		else if(en)
			sum <= (Mc & E) ^ carry ^ I;

	//---------------------------------------------
	// carry register
	//---------------------------------------------
	always @ (posedge C or posedge R)
		if(R)
			carry <= 0;
		else if (sC)
			carry <= 0;
		else if (en)
			carry <= ((Mc & E) ^ carry) & (I ^ A);
	
	//---------------------------------------------
	// multiplicand register
	//---------------------------------------------
	always @ (posedge C or posedge R)
		if(R)
			Mc <= 0;
		else if(L) 
			Mc <= M;
	
	assign O = sum;
	
endmodule
